;PUREBASIC EasyVENT.
;Public structures and constants.


;The following enumeration lists the possible events we can create handlers for.
Enumeration 
  #OnANYevent     ;Careful with this one! (Added to EasyVENT 3.0.1)
  #OnCursorEnter
  #OnCursorExit
  #OnDblClick
  #OnMouseDown
  #OnMouseOver
  #OnMouseUp
  #OnUnhandledWinMessage
  #OnClose
  #OnGotFocus
  #OnLostFocus
  #OnMaximize
  #OnMinimize
  #OnDragItemStart
  #OnDropItem
  #OnMove
  #OnErase
  #OnPaint
  #OnResize
  #OnItemCheckboxChanging
  #OnItemSelecting
  #OnItemSelected
  #OnScroll
  #OnSetCursor
  #OnSizingWindow
  #xxx_endofstandardevents
  #OnContextmenuPopup
  #OnKeyDown
  #OnKeyPress
  #OnKeyUp
  #xxx_endofkeyevents
  #OnButtonClick
  #OnChange
  #OnCollapseExpandSelection ;Tree gadgets only.
  #OnDragDrop
  #OnLinkClick ;Editor gadgets only.
  #OnMenuItemSelect
  #OnEditTreeLabels ;Tree gadgets only. 
EndEnumeration

;The following enumeration lists the valid return values from an event handler.
Enumeration
  #Event_ReturnDefault
  #Event_ReturnTrue
  #Event_ReturnFalse
EndEnumeration

;The following enumeration is used for mouse clicks etc. to indicate which button was pressed.
Enumeration
  #Event_LeftButton
  #EVENT_MIDDLEBUTTON
  #EVENT_RIGHTBUTTON
EndEnumeration

;The following enumeration is used for certain 'sepecialised' events.
Enumeration
  #EVENT_DESELECT   ;An item has been deselected - ListIcons.
  #EVENT_SELECT     ;An item has been selected - ListIcons.
  #EVENT_CHECKING = 1 ;The user is attempting to clear a checkbox item in a listicon or 
                        ;tree gadget. 
  #EVENT_UNCHECKING       ;The user is attempting to check a checkbox item in a listicon or 
                        ;tree gadget. 
EndEnumeration

;The following enumeration is used when the various means of differentiating a selection are important.
Enumeration
  #EVENT_UNKNOWN
  #EVENT_MOUSE
  #EVENT_KEYBOARD
EndEnumeration

;The following enumeration is used for many of the stadard mouse events to indicate whether the event
;occured in the client area or non-client area of the control.
Enumeration
  #EVENT_CLIENT
  #EVENT_NONCLIENT
EndEnumeration


#EVENT_COLLAPSE=#TVE_COLLAPSE
#EVENT_EXPAND=#TVE_EXPAND
#EVENT_BEGINLABELEDIT=#TVN_BEGINLABELEDIT
#EVENT_ENDLABELEDIT=#TVN_ENDLABELEDIT


;Structure passed to event handlers containing information which might be required to
;process the event etc. It is also used to return changes to Windows message parameters.
Structure PB_Sender
  hwnd.i
  message.i
  mousex.i        ;Client co-ordinates relative to the underlying control (not the parent window)
  mousey.i        ;Client co-ordinates relative to the underlying control (not the parent window)
  button.i        ;For click events this indicates which mouse button was clicked etc.
                  ;#EVENT_LEFTBUTTON etc.
  item.i          ;Used with certain events \ controls to indicate a particular item. 
  state.i         ;Gives extra information for certain events.
  text$           ;Gives extra information for certain events.
  originalmessage.i ;Used in #OnUnhandledWinMessage only to indicate the underlying event (if any).
  ;Take extreme care if altering the following three fields in an event handler!
  ;These are used when performing default Win processing via the command PerformDefaultWinProcessing().
    uMsg.i          ;Windows callback message parameter (when appropriate)
    wParam.i        ;Windows callback message parameter (when appropriate)
    lParam.i        ;Windows callback message parameter (when appropriate)
  ;ABSOLUTELY DO NOT use the following three fields! An application crasher! A hard drive wrecker! A destroyer of lives!
  ;You've been warned!
    res1.i
    res2.i
    res3.i
EndStructure


; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 103
; FirstLine = 85