;EasyVENT demonstration program - general.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES A NUMBER OF EVENTS.
;*********************************************************************************


;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************


Declare.l ButtonClick(*sender.PB_Sender)
Declare.l EnterListIcon(*sender.PB_Sender)
Declare.l ExitListIcon(*sender.PB_Sender)
Declare.l ActivateString(*sender.PB_Sender)
Declare.l MouseOver(*sender.PB_Sender)
Declare.l SizeWin(*sender.PB_Sender)
Declare.l MaxMinWin(*sender.PB_Sender)
Declare.l MenuLoad(*sender.PB_Sender)
Declare.l Close(*sender.PB_Sender)

Define Event.l

OpenWindow(0, 100, 100, 600, 600, "Event example - TRY MAXIMIZING / MINIMIZING the window!", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

If CreateMenu(0, WindowID(0))
  MenuTitle("File")
    MenuItem(1, "Click this!")
    MenuItem(2, "No event set up here!")
EndIf
If CreateToolBar(0, WindowID(0))
  ToolBarStandardButton(1, #PB_ToolBarIcon_New) : ToolBarToolTip(0, 1, "Click this!")
  ToolBarStandardButton(2, #PB_ToolBarIcon_Open) : ToolBarToolTip(0, 2, "No event set up here!")

EndIf

  ContainerGadget(0, 8, 25, 306, 250, #PB_Container_Raised) 
    ButtonGadget(1, 5, 15, 80, 24, "Click button") 
    ListIconGadget(2,5,65,140,80,"Cursor enter/exit",100) 
    StringGadget(3, 5, 180, 120, 20, "Activate string gadget")

  CloseGadgetList() 
OpenWindow(1, 10, 10, 200, 200, "Click or size window", #PB_Window_SizeGadget|#PB_Window_ScreenCentered,WindowID(0))

  TextGadget(4, 5, 15, 120, 20, "Mouse over text gadget")

;Set event handlers.
;Note one handler can easily handle multiple events/controls.
SetEventHandler(WindowID(0), #OnClose, @Close())
SetEventHandler(GadgetID(1), #OnButtonClick, @ButtonClick())
SetEventHandler(GadgetID(2), #OnCursorEnter, @EnterListIcon())
SetEventHandler(GadgetID(2), #OnCursorExit, @ExitListIcon())
SetEventHandler(GadgetID(3), #OnGotFocus, @ActivateString())
SetEventHandler(WindowID(1), #OnMouseDown, @ButtonClick())
SetEventHandler(WindowID(1), #OnResize, @SizeWin())
SetEventHandler(WindowID(0), #OnMaximize, @MaxMinWin())
SetEventHandler(WindowID(0), #OnMinimize, @MaxMinWin())
SetEventHandler(GadgetID(4), #OnMouseOver, @MouseOver())

;Attach handlers to menu items.
SetEventHandler(WindowID(0), #OnMenuItemSelect, @MenuLoad(),1)

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************

;The following handler shows how one handler can handle multiple events/controls.
Procedure.l ButtonClick(*sender.PB_Sender)
  If *sender\message = #OnButtonClick Or (*sender\message = #OnMouseDown And *sender\state = #EVENT_CLIENT)
    Debug "Click"
  EndIf
  PerformDefaultWinProcessing(*sender) ;To handle the #OnMouseUp event.
ProcedureReturn #Event_ReturnDefault 
EndProcedure

Procedure.l EnterListIcon(*sender.PB_Sender)
  Debug "Enter"
ProcedureReturn #Event_ReturnTrue  ;Return not important.
EndProcedure

Procedure.l ExitListIcon(*sender.PB_Sender)
  Debug "Exit"
ProcedureReturn #Event_ReturnTrue  ;Return not important.
EndProcedure

Procedure.l ActivateString(*sender.PB_Sender)
  PerformDefaultWinProcessing(*sender)
  Debug "Activate"
ProcedureReturn #Event_ReturnTrue  ;Return not important.
EndProcedure

Procedure.l MouseOver(*sender.PB_Sender)
  Debug "Mouse over"
ProcedureReturn #Event_ReturnTrue ;Return not important this time. 
EndProcedure

Procedure.l SizeWin(*sender.PB_Sender)
  Debug "Sizing"
ProcedureReturn #Event_ReturnTrue  ;Return not important.
EndProcedure

Procedure.l MaxMinWin(*sender.PB_Sender)
;Uncomment the following line to allow the max/min.
;  PerformDefaultWinProcessing(*sender)
  Debug "Max or min is being prohibited!"
  ProcedureReturn #Event_ReturnDefault
EndProcedure

Procedure.l MenuLoad(*sender.PB_Sender)
  Debug "Clicked menu/toolbar item: " + Str(*sender\wParam & $FFFF)
  ProcedureReturn #Event_ReturnTrue  ;Return not important.
EndProcedure

Procedure.l Close(*sender.PB_Sender)
  MessageRequester("#OnClose", "Close button clicked.")
  PerformDefaultWinProcessing(*sender)
  ProcedureReturn #Event_ReturnFalse
EndProcedure

; IDE Options = PureBasic 4.10 Beta 3 (Windows - x86)
; CursorPosition = 44
; FirstLine = 30
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 42
; FirstLine = 40
; Folding = --
; EnableXP