;EasyVENT demonstration program - Drag and drop items 1 (simple example!)
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
;  #OnStartDragItem, #OnDropItem
;
;This demo shows how easy it is to drag and drop items from just about any gadget
;using EasyVENT.
;*********************************************************************************

OleInitialize_(0)

;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************


Declare.l DragItem(*sender.PB_Sender)
Declare.l DropItem(*sender.PB_Sender)

Define Event.l

LoadFont(1, "Tahoma", 14)



OpenWindow(0, 100, 100, 400, 240, "EasyVENT OLE drag and drop items demo 1.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)
  TextGadget(0, 10, 10, 150, 20, "Drag from this text gadget!")
  TextGadget(1,10,40,150,40,"And from"+Chr(10)+Chr(13)+"this one!") 
  TextGadget(2,10,80,150,30,"And this!") 
  TextGadget(3, 200, 10, 150, 20, "Drag to the list view gadget!")
SetGadgetFont(2,FontID(1))
  ListViewGadget(4,200,30,150,150)
SetActiveGadget(1)
;Set event handlers.
  SetEventHandler(GadgetID(0), #OnDragItemStart, @DragItem())
  SetEventHandler(GadgetID(1), #OnDragItemStart, @DragItem())
  SetEventHandler(GadgetID(2), #OnDragItemStart, @DragItem())
  SetEventHandler(GadgetID(4), #OnDropItem, @DropItem())
;Enable drops to the ListView gadget.
  EnableGadgetDrop(4, #PB_Drop_Text,#PB_Drag_Copy|#PB_Drag_Move)

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************


;The return value is unimportant.
;Notice how we determine whether the user wishes to copy or move the object etc.
;(although we don't actually delete the original in this case if the user wishes to move
;the object!)
Procedure.l DragItem(*sender.PB_Sender)
  Protected action = #PB_Drag_Move 
  If *sender\wParam & #MK_CONTROL	
    action = #PB_Drag_Copy
  EndIf
;Determine which gadget is being dragged from.
  Select *sender\hwnd
    Case GadgetID(0)
      DragText(GetGadgetText(0),action)
    Case GadgetID(1)
      DragText(GetGadgetText(1),action)
    Case GadgetID(2)
      DragText(GetGadgetText(2),action)
  EndSelect
EndProcedure


;The return value is unimportant.
Procedure.l DropItem(*sender.PB_Sender)
  Protected text$, i, count
  If EventDropType() = #PB_Drop_Text
    text$ = EventDropText()
    ;First remove any line feed / carriage returns from the dragged string.
      text$=ReplaceString(text$,Chr(10)+Chr(13)," ")
    ;Now account for the fact that we might have dragged from demo 2 !!!
      count = CountString(text$,Chr(9))+1
      For i = 1 To count
        AddGadgetItem(4,-1, StringField(text$,i,Chr(9))) ;Copy item to ListIcon.
      Next
  EndIf
EndProcedure

; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 86
; FirstLine = 50
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 41
; FirstLine = 26
; Folding = -