;EasyVENT demonstration program - general.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES #OnUnhandledWinMessage, by colouring a static control.
;*********************************************************************************


;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************

Global GadgetBackground, GadgetForeground 
GadgetBackground = CreateSolidBrush_(#Blue) 
GadgetForeground = #Red

Declare.l StaticProc(*sender.PB_Sender)

Define event.l

OpenWindow(0, 100, 100, 600, 600, "Colour static control.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

  TextGadget(1, 5, 15, 120, 20, "Text gadget")
;SetGadgetColor(1,#PB_Gadget_BackColor ,#Red)
;Set event handlers.
;We are interested in #WM_CTLCOLORSTATIC, which is sent to the parent window. Hence we
;set a handler for the main window.
  SetEventHandler(WindowID(0), #OnUnhandledWinMessage, @StaticProc())

;Force a recolouring of the text gadget.
  InvalidateRect_(GadgetID(1),0,1)

Repeat
  event = WaitWindowEvent()
Until event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************

Procedure.l StaticProc(*sender.PB_Sender)
  Protected result
  Select *sender\uMsg
    ;First deal with all Windows messages that we require to handle.
      Case #WM_CTLCOLORSTATIC
        If *sender\lParam=GadgetID(1)
          SetBkMode_(*sender\wParam,#TRANSPARENT) 
          SetTextColor_(*sender\wParam,GadgetForeground) 
          result = GadgetBackground 
        EndIf
    ;Now deal with all remaining Windows messages by passing them back for default processing.
      Default
        result = PerformDefaultWinProcessing(*sender)
  EndSelect
  ProcedureReturn result
EndProcedure

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 27
; FirstLine = 13
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 56
; FirstLine = 32
; Folding = -