;EasyVENT demonstration program - Panel gadgets.
;*********************************************************************************
;
;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
; #OnButtonClick, #OnMouseOver, #OnItemSelecting

;This short demo shows how to use EasyVENT to quickly determine when a user selects a new tab etc.
;It also shows how to prevent the user from selecting particular tabs.
;*********************************************************************************

Define Event.l

;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************
Declare.l ButtonClick(*sender.PB_Sender)
Declare.l MouseOver(*sender.PB_Sender)
Declare.l SelectItem(*sender.PB_Sender)

OpenWindow(0, 100, 100, 350, 250, "EasyVENT PanelGadget demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

  PanelGadget(0, 8, 8, 306, 203)
      AddGadgetItem (0, -1, "Panel 1")
        PanelGadget (1, 5, 5, 290, 166)
          AddGadgetItem(1, -1, "Sub-Panel 1")
            ButtonGadget(2, 10, 15, 80, 24,"Click me!")
            ButtonGadget(3, 95, 15, 80, 24,"Don't bother!")
            TextGadget(4,10,50,200,20, "Mouse over this panel!")
          AddGadgetItem(1, -1, "Sub-Panel 2")
          AddGadgetItem(1, -1, "Sub-Panel 3")
        CloseGadgetList()
      AddGadgetItem (0, -1,"No select!")
      AddGadgetItem (0, -1,"Select away!")

;Set event handlers.
SetEventHandler(GadgetID(2), #OnButtonClick, @ButtonClick())
;The following shows one way of attaching an event directly to a panel
;Gadgets in panels are no problem, just the panels themselves! See user guide.
SetEventHandler(GetParent_(GadgetID(2)), #OnMouseOver, @MouseOver()) 
SetEventHandler(GadgetID(0), #OnItemSelecting, @SelectItem())
SetEventHandler(GadgetID(1), #OnItemSelecting, @SelectItem())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************

Procedure.l ButtonClick(*sender.PB_Sender)
  Debug "Clicked button 1."
ProcedureReturn #Event_ReturnTrue ;Return not inportant.
EndProcedure

Procedure.l MouseOver(*sender.PB_Sender)
  Debug "Mouseover static control."
ProcedureReturn #Event_ReturnTrue ;Return not inportant this time.
EndProcedure

Procedure.l SelectItem(*sender.PB_Sender)
  If *sender\hwnd=GadgetID(0) And *sender\item=1
    ProcedureReturn #Event_ReturnFalse
  EndIf
  Debug "Selected tab: " + Str(*sender\item)
ProcedureReturn #Event_ReturnTrue ;Return not important.
EndProcedure

; IDE Options = PureBasic 4.10 Beta 2 (Windows - x86)
; CursorPosition = 50
; FirstLine = 39
; IDE Options = PureBasic 4.40 Beta 6 (Windows - x86)
; CursorPosition = 42
; FirstLine = 21
; Folding = -
; EnableXP