;EasyVENT demonstration program - Spin gadgets.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
; #OnScroll
;
;The reason I had to use the #OnScroll event to trap changes to Spin gadgets is to avoid possible
;infinite loops as can be the case if using the #OnChange event with these gadgets.
;*********************************************************************************

Define Event.l

;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************
Declare.l Change(*sender.PB_Sender)

OpenWindow(0, 100, 100, 350, 250, "EasyVENT SpinGadget demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

  SpinGadget(0, 20, 20, 100, 25, 10, 1000, #PB_Spin_Numeric)
  SetGadgetState(0, 15) : SetGadgetText(0, "15") 
;Set event handlers.
SetEventHandler(GadgetID(0), #OnScroll, @Change())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************
;*sender\item contains the new value of the spin gadget. Of course you can get this by using
;GetGadgetState() etc.
;*sender\state contains the scroll bar code.
;*sender\hWnd contains the handle of the SpinGadget.
;*sender\uMsg contains #WM_VSCROLL.
Procedure.l Change(*sender.PB_Sender)
  If *sender\state=#SB_ENDSCROLL	
    Debug "Spinning finished!"
  Else
    Debug "Spinning!"
  EndIf
  SetGadgetText(0,Str(GetGadgetState(0)))
  ProcedureReturn #Event_ReturnTrue  ;Return not important for spin gadgets. No harm in calling 
                                     ;PerformDefaultWinProcessing() though.
EndProcedure

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 46
; FirstLine = 11
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; CursorPosition = 47
; FirstLine = 23
; Folding = -