;EasyVENT demonstration program - Splitter gadgets.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
; #OnReSize, #OnMouseDown, #OnSetCursor.
;
;This example uses a #OnReSize handler attached to the main window to show how simple EasyVENT
;makes resizing windows containing splitter gadgets etc.
;It also shows how attaching mouse events to a splitter gadget can be used to prohibit the user
;from dragging a splitter (not sure why we'd want to do this though!)
;*********************************************************************************

Define Event.l, text$

;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************
Declare.l Size(*sender.PB_Sender)
Declare.l Mouse(*sender.PB_Sender)
Declare.l MouseOver(*sender.PB_Sender)

OpenWindow(0, 100, 100, 400, 250, "EasyVENT SplitterGadget demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered|#PB_Window_SizeGadget)

  ListIconGadget(0, 0, 0, 0, 0, "Test", 100) 
    AddGadgetItem(0, -1, "List Icon Gadget 1") 
    
  ListIconGadget(1, 0, 0, 0, 0, "Test", 100) 
    AddGadgetItem(1, -1, "List Icon Gadget 2") 

  text$="EasyVENT is preventing the vertical splitter gadget from being moved!"+Chr(10)+Chr(13)     
  text$+Chr(10)+Chr(13)+"It is also assisting when the user resizes the window. Try it!"

  TextGadget(3, 0, 0, 0, 0, text$) 

  SplitterGadget(2,0,0,0,0,3,0,#PB_Splitter_Separator |#PB_Splitter_Vertical) 
  SplitterGadget(4,10,10, WindowWidth(0)-20, WindowHeight(0)-20,2,1,#PB_Splitter_Separator) 

;Set event handlers.
SetEventHandler(WindowID(0), #OnResize, @Size())
;The following 2 events are handled by the same handler.
SetEventHandler(GadgetID(2), #OnMouseDown, @Mouse())
SetEventHandler(GadgetID(2), #OnSetCursor, @Mouse())



Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************
Procedure.l Size(*sender.PB_Sender)
  ResizeGadget(4,10,10, WindowWidth(0)-20, WindowHeight(0)-20) 
  ProcedureReturn #Event_ReturnFalse
EndProcedure

;The following event handler is attached to the vertical Splitter gadget and handles the
;events; #OnMouseDown and #OnSetCursor.
;It prevents the user from dragging the separator and also prevents windows from setting the
;cursor to indicate sizing etc.
Procedure.l Mouse(*sender.PB_Sender)
  SetCursor_(LoadCursor_(0,#IDC_ARROW)) 
  ProcedureReturn #Event_ReturnDefault
EndProcedure

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 63
; FirstLine = 25
; IDE Options = PureBasic 4.30 Alpha 1 (Windows - x86)
; CursorPosition = 26
; Folding = -