;EasyVENT demonstration program - TrackBar gadgets.
;*********************************************************************************

;(Checked working with EasyVENT 3.0.0)

;DEMONSTRATES THE FOLLOWING EVENTS:
; #OnScroll
;
;TrackBar gadgets are handled in exactly the same way as SpinGadgets.
;*********************************************************************************

Define Event.l

;ESSENTIAL INCLUDE.
;*********************************************************************************
XIncludeFile "EasyVENT.pbi"
;*********************************************************************************
Declare.l Change(*sender.PB_Sender)

OpenWindow(0, 100, 100, 350, 250, "EasyVENT TrackBarGadget demo.", #PB_Window_SystemMenu |#PB_Window_MinimizeGadget|#PB_Window_MaximizeGadget| #PB_Window_ScreenCentered)

  TrackBarGadget(0, 10,  40, 250, 20, 0, 100)

;Set event handlers.
SetEventHandler(GadgetID(0), #OnScroll, @Change())

Repeat
  Event = WaitWindowEvent()
Until Event = #PB_Event_CloseWindow
End


;*********************************************************************************
;                                 EVENT HANDLERS
;*********************************************************************************
;*sender\item contains the new value of the TrackBar gadget. Of course you can get this by using
;GetGadgetState() etc.
;*sender\state contains the track bar code.
;*sender\hWnd contains the handle of the TrackBarGadget.
;*sender\uMsg contains #WM_HSCROLL or #WM_VSCROLL as appropriate.
Procedure.l Change(*sender.PB_Sender)
  If *sender\state<>#SB_ENDSCROLL	And *sender\state<>#SB_THUMBPOSITION
    Debug GetGadgetState(0)
  ElseIf *sender\state=#SB_ENDSCROLL	
    Debug "Scrolling finished!"
  EndIf
  ProcedureReturn #Event_ReturnFalse ;Return not important for trackbar gadgets. No harm in calling 
                                     ;PerformDefaultWinProcessing() though.
EndProcedure


; IDE Options = PureBasic 4.30 Alpha 1 (Windows - x86)
; CursorPosition = 21
; Folding = -